<template>
    <v-row>
        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">
                    <h1 class="pb-8">Création d'un devis</h1>
                    <CreateForm :data="form"/>
                    <v-btn @click="createDevis" color="primary" size="large" flat>Créer le devis</v-btn>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<script lang="ts">
    import CreateForm from '~/components/crud/CreateForm.vue';
    import { ref } from 'vue';

    export default {
        components: {
            CreateForm
        },
        async setup() {
            const responseClients = await fetch('http://localhost:8000/api/clients', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseDataClients = await responseClients.json();
            const clients = responseDataClients['hydra:member'];
            let clientVar = [];
            for (const client of clients) {
                clientVar.push(client.nom);
            }

            const form = ref({
                dateCreation: {
                    formType: 'date',
                    label: 'Date de création',
                    value: '',
                    rules: 'required|string',
                    colLenght: 4
                },
                client : {
                    formType: 'select',
                    label: 'Client',
                    value: '',
                    rules: 'required|string',
                    colLenght: 8,
                    items : clientVar
                },
                productsTable : {
                    formType: 'table',
                    label: 'Produits',
                    value: '',
                    rules: 'required|string',
                    colLenght: 12,
                    thead : ['Nom', 'Description', 'Prix unitaire', 'Quantité', 'Total'],
                    tbody : [],
                    addProductButton: true
                }
            });

            const createDevis = async () => {
                let products = [];
                for (const product of form.value.productsTable.tbody) {
                    products.push("/api/produits/" + product.id);
                }
                const responseDetailDevis = await fetch('http://localhost:8000/api/detail_deviss', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/ld+json',
                    },
                    body: JSON.stringify({
                        product: products,
                        quantite: 1,
                        prix_unitaire: null,
                    })
                });
                let responseDetailDevisData = await responseDetailDevis.json();
                const response = await fetch('http://localhost:8000/api/deviss', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/ld+json',
                    },
                    body: JSON.stringify({
                        client: "/api/clients/" + clients.find((client) => client.nom === form.value.client.value)?.id,
                        date_creation: form.value.dateCreation.value,
                        statut: 'En attente',
                        detail_devis: "/api/detail_deviss/" + responseDetailDevisData.id
                    })
                });
                navigateTo('/devis/list');
            }

            return {
                form,
                createDevis
            }
        }
    }

</script>